#编程库
import dispy,socket

#求指定范围内的素数
def compute(min_n,max_n):
    import socket,math
    host = socket.gethostname()     #获取节点计算机的名称
    num=[];
    if (min_n<2):min_n=2
    for i in range(min_n, max_n):   #查找素数
        for j in range(2,i):
            if(i%j==0):break
        else:
            num.append(i)
    return (host,num)               #返回计算结果

#显示计算结果
def status(status, node, job):
    if status == dispy.DispyJob.Finished:
        print('素数 %s: %s' % (job.id, job.result))
    elif status == dispy.DispyJob.Terminated:
        print('sha1sum for %s failed: %s' % (job.id, job.exception))

#获取本机IP
ip = socket.gethostbyname(socket.gethostname())
#组织参与计算的计算机
cluster = dispy.JobCluster(compute,ip_addr=ip,cluster_status=status)
#查看系统中的计算节点
cluster.print_status()

#把计算60000以内的素数这一任务，分为10段进行分配
for i in range(0,10):
    cluster.submit(i*10000,(i+1)*10000)

#关闭集群
cluster.close()