import http.server
import socketserver
import ssl

#端口
PORT=8000
Handler = http.server.SimpleHTTPRequestHandler
httpd = socketserver.TCPServer(("127.0.0.1", PORT), Handler)
print("serving at port", PORT)

#增加对SSL的支持，keyfile是私钥，cerfile是证书
httpd.socket = ssl.wrap_socket(httpd.socket, keyfile='pr_key.bin',
        certfile='abc.pem', server_side=True)
httpd.serve_forever()
